/*----- PROTECTED REGION ID(VgClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        VgClass.h
//
// description : Include for the VgClass root class.
//               This class is the singleton class for.
//               the Vg device class..
//               It contains all properties and methods which the .
//               Vg requires only once e.g. the commands.
//
// project :     Vg.
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef VGCLASS_H
#define VGCLASS_H

#include <tango.h>
#include <Vg.h>

/*----- PROTECTED REGION END -----*/	//	VgClass.h


namespace Vg_ns
{
/*----- PROTECTED REGION ID(VgClass::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	VgClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Pressure class definition
class PressureAttrib: public Tango::Attr
{
public:
	PressureAttrib():Attr("Pressure",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~PressureAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Vg *>(dev))->read_Pressure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Vg *>(dev))->is_Pressure_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OnClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Vg *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OffClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Vg *>(dev))->is_Off_allowed(any);}
};


/**
 *	The VgClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  VgClass : public Tango::DeviceClass
#else
class VgClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(VgClass::Additional DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	VgClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static VgClass *init(const char *);
		static VgClass *instance();
		~VgClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		VgClass(std::string &);
		static VgClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	Vg_H
